//+------------------------------------------------------------------+
//|                                              Bollinger_Bands.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Gray
#property indicator_color2 LightGreen
#property indicator_color3 Red

//---- indicator parameters
extern int    BandsPeriod=20;
extern int    BandsShift=0;
extern double BandsDeviations=2.0;
extern int  SIGNAL_BAR = 2;
extern bool AlertPossible    = true;
extern bool AlertOnlySound   = false;
extern bool SoundBuy  = true;
extern bool SoundSell = true;
extern string Sound          = "alert2.wav";
extern bool SendMailPossible = false;
//---- buffers
double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MovingBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,UpperBuffer);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,LowerBuffer);
//----
   SetIndexDrawBegin(0,BandsPeriod+BandsShift);
   SetIndexDrawBegin(1,BandsPeriod+BandsShift);
   SetIndexDrawBegin(2,BandsPeriod+BandsShift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double deviation;
   double sum,oldval,newres;
//----
   if(Bars<=BandsPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=BandsPeriod;i++)
        {
         MovingBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer[Bars-i]=EMPTY_VALUE;
         LowerBuffer[Bars-i]=EMPTY_VALUE;
        }
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      MovingBuffer[i]=iMA(NULL,0,BandsPeriod,BandsShift,MODE_SMA,PRICE_CLOSE,i);
//----
   i=Bars-BandsPeriod+1;
   if(counted_bars>BandsPeriod-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      sum=0.0;
      k=i+BandsPeriod-1;
      oldval=MovingBuffer[i];
      while(k>=i)
        {
         newres=Close[k]-oldval;
         sum+=newres*newres;
         k--;
        }
      deviation=BandsDeviations*MathSqrt(sum/BandsPeriod);
      UpperBuffer[i]=oldval+deviation;
      LowerBuffer[i]=oldval-deviation;
      i--;
     }
  //+------------------------------------------------------------------+
 static int PrevSignal = 0, PrevTime = 0;

	  if(SIGNAL_BAR > 0 && Time[0] <= PrevTime) 
	      return(0);

	  PrevTime = Time[0];

     if (AlertPossible == true) {
	 if( SoundBuy==true)
      {
      
        if( Close[SIGNAL_BAR] < LowerBuffer[SIGNAL_BAR] ){
        if (AlertOnlySound) {PlaySound(Sound);} else 
          {
            
            Alert(" Bollinger_Bands (", Symbol(), ", ", Period(), ")  -  BUY!!!");PlaySound(Sound);
            if (SendMailPossible) SendMail(Symbol()+ " M"+ Period()+ "  Bollinger_Bands  -  BUY!!!", "");
          }
      }
      }
    if(  SoundSell == true)
      {
        if( Close[SIGNAL_BAR] >= UpperBuffer[SIGNAL_BAR ] ){
        if (AlertOnlySound) {PlaySound(Sound);} else 
          {
            
            Alert(" Bollinger_Bands (", Symbol(), ", ", Period(), ")  -  SELL!!!");PlaySound(Sound);
            if (SendMailPossible) SendMail(Symbol()+ " M"+ Period()+ "  Bollinger_Bands   -  SELL!!!", "");
          }
      }
      }
      }
//+------------------------------------------------------------------+ 
//----
   return(0);
  }
//+------------------------------------------------------------------+